<template>
	<pi-table ref="tableRef" :api="api.system.config.list" @selection-change="selectionChange">
		<template #do>
			<el-button v-auth="'system_config:add'" type="primary" icon="el-icon-plus" @click="add"></el-button>
			<el-button v-auth="'system_config:edit'" type="success" icon="el-icon-edit" @click="edit"
					   :disabled="selection.length!==1"></el-button>
			<el-button v-auth="'system_config:del'" type="danger" plain icon="el-icon-delete"
					   :disabled="selection.length===0" @click="batch_del"></el-button>
		</template>
		<template #search>
			<el-input v-model="search.config_name" placeholder="参数名称" clearable style="width: 200px;"></el-input>
			<el-input v-model="search.config_key" placeholder="参数键名" clearable style="width: 200px;"></el-input>
			<el-button type="primary" icon="el-icon-search" @click="upsearch"></el-button>
		</template>
		<el-table-column type="selection" width="50"></el-table-column>
		<el-table-column label="ID" prop="config_id"></el-table-column>
		<el-table-column label="参数名称" prop="config_name"></el-table-column>
		<el-table-column label="参数键名" prop="config_key"></el-table-column>
		<el-table-column label="备注" prop="remark"></el-table-column>
		<el-table-column label="创建时间" prop="create_time"></el-table-column>
		<el-table-column label="更新时间" prop="update_time"></el-table-column>
		<el-table-column label="操作" fixed="right" align="right" width="170">
			<template #default="scope">
				<el-button-group>
					<el-button text type="primary" size="small" @click="show(scope.row, scope.$index)">查看
					</el-button>
					<el-button v-auth="'system_config:edit'" text type="success" size="small"
							   @click="edit(scope.row, scope.$index)">编辑
					</el-button>
					<el-popconfirm title="确定删除吗？" @confirm="del(scope.row, scope.$index)">
						<template #reference>
							<el-button v-auth="'system_config:del'" text type="danger" size="small">删除</el-button>
						</template>
					</el-popconfirm>
				</el-button-group>
			</template>
		</el-table-column>
	</pi-table>
	<save-dialog v-if="dialogShow" ref="dialogRef" @success="tableRef.refresh()" @closed="dialogShow=false"></save-dialog>
</template>

<script setup>
import saveDialog from './save'
import api from "@/api/index"
import {getCurrentInstance, nextTick, ref} from "vue"

defineOptions({
	name: "systemConfig"
})

const {proxy} = getCurrentInstance()
const tableRef = ref(null)
const dialogRef = ref(null)

let dialogShow = ref(false)
let selection = ref([])
let search = ref({
	config_name: null,
	config_key: null,
	config_value: null,
	remark: null,
})

//添加
function add() {
	dialogShow.value = true
	nextTick(() => {
		dialogRef.value.open()
	})
}

//编辑
function edit(row) {
	dialogShow.value = true
	nextTick(() => {
		if (row instanceof PointerEvent) {
			row = selection.value[0]
		}
		dialogRef.value.open('edit', row || selection.value[0])
	})
}

//查看
function show(row) {
	dialogShow.value = true
	nextTick(() => {
		dialogRef.value.open('show', row)
	})
}

//删除
async function del(row) {
	const loading = proxy.$loading();
	const res = await api.system.config.del({ids: [row.config_id]});
	tableRef.value.refresh()
	loading.close();
	proxy.$message.success(res.msg)
}

//批量删除
async function batch_del() {
	proxy.$confirm(`确定删除选中的 ${selection.value.length} 项吗？如果删除项中含有子集将会被一并删除`, '提示', {
		type: 'warning'
	}).then(async () => {
		const loading = proxy.$loading();
		const res = await api.system.config.del({ids: selection.value.map(item => item.config_id)});
		tableRef.value.refresh()
		loading.close();
		proxy.$message.success(res.msg)
	})
}

//表格选择后回调事件
function selectionChange(e) {
	selection.value = e;
}

//搜索
function upsearch() {
	tableRef.value.upData(search.value)
}
</script>
